/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package exercise.stub;

import java.util.Objects;

public class Employee {

	private String name;
	private String surname;
	private int salary;

	public Employee(String name, String surname, int salary) {
		if (name == null || name.isEmpty()) {
			throw new IllegalArgumentException("name");
		}
		if (surname == null || surname.isEmpty()) {
			throw new IllegalArgumentException("surname");
		}
		if (salary < 0) {
			throw new IllegalArgumentException("salary");
		}

		this.name = name;
		this.surname = surname;
		this.salary = salary;
	}

	public String getName() {
		return name;
	}

	public String getSurname() {
		return surname;
	}

	public int getSalary() {
		return salary;
	}

	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof Employee)) {
			return false;
		}
		Employee other = (Employee) obj;
		return name.equals(other.name) && surname.equals(other.surname) && salary == other.salary;
	}

	@Override
	public int hashCode() {
		return Objects.hash(name, surname, salary);
	}

	@Override
	public String toString() {
		return name + " " + surname + " $" + salary;
	}

}
