/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package exercise.stub;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Map;

public class EmployeeManager {

	private Database data;

	public EmployeeManager(Database data) {
		this.data = data;
	}

	public Collection<Employee> getByName(String name) {
		List<Employee> selectedEmployees = new ArrayList<>();

		Collection<Map<String, String>> selectedRows;
		try {
			//PreparedStatement should be ussed here.
			//Never fill arguments directly from input using concatenation!
			//Handling arguments like this makes you wulnerable to SQL injection
			selectedRows = data.query("SELECT name, surname, salary FROM employee WHERE name = '" + name + "'");
		} catch (DatabaseException e) {
			return Collections.emptyList();
		}
		for (Map<String, String> serialized : selectedRows) {
			try {
				selectedEmployees.add(createEmployee(serialized));
			} catch (IllegalArgumentException e) {
				//log error e and keep going
			}
		}
		return Collections.unmodifiableList(selectedEmployees);
	}

	private Employee createEmployee(Map<String, String> serialized) {
		String name = serialized.get("name");
		String surname = serialized.get("surname");
		int salary = Integer.parseInt(serialized.get("salary"));
		return new Employee(name, surname, salary);
	}
}
